/*
 * File......: FIELD.PRG
 * Author....: Steve Kolterman
 * CIS ID....: 76320,37
 * Date......: $Date:   02 Apr 1991 18:22:52  $
 * Revision..: $Revision:   1.0  $
 * Log file..: $Logfile:   E:/nanfor/src/field.prv  $
 * 
 * This is an original work by Steve Kolterman and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log:   E:/nanfor/src/field.prv  $
*  
*     Rev 1.0   02 Apr 1991 18:22:52   GLENN
*  Nanforum Toolkit
 *
 */

#define FGV   fieldget( var )
#define VTFGV valtype( (FGV) )
#define FBV   FieldBlock(var)
#define FV    Eval( (FBV) )
#define VTFV  valtype( FV )
#define VTV   valtype( var )
#define TNUM  IF( !(VTV) $"NC",NIL,IF( (VTV)=="N",(VTFGV),(VTFV) ))
#define TCHR  IF( !(VTV) $"NC",NIL,IF( (VTV)=="N",(FGV),(FV) ))
#define DBS_NAME 1
#translate ATRIM( <x> ) => LTRIM(TRIM( <x> ))


#ifdef FT_TEST

  #DEFINE NTOC(v) LTRIM(STR( v ))
  #define K_ESC 27

  FUNCTION Tester( dbff,numrecs )
     LOCAL oldcolor:= SETCOLOR(),xx,start,end,key:= 0,fc

     IF (dbff <> NIL) .AND. ( FILE( dbff ) .OR. FILE( dbff+".DBF" ) )
        cls; numrecs:= IF( numrecs==NIL,1,VAL(numrecs) )
        USE (dbff); fc:= fcount()

        WHILE numrecs > 0 .AND. key <> K_ESC
           FOR xx:= 1 to fc
              start:= Seconds()
              ? "Testing SK Field Functions..."
              ? "  DATABASE: ",dbff
              ? "    FIELDS: ",NTOC(fcount())
              ? "    RECORD: ",NTOC(RECNO())
              ? "FIELD NAME: ",fieldname(xx)
              ?
              ? "RETURN values passing a name... "
              ? "  CONTENTS: ",FT_FVAL( fieldname(xx) )
              ? "VALUE LENG: ",NTOC( FT_FVALLEN( fieldname(xx) ) )
              ? "FIELD NUMB: ",NTOC( FT_FNUM( fieldname(xx) ) )
              ? "FIELD TYPE: ",FT_FTYPE( fieldname(xx) )
              ? "FIELD LENG: ",NTOC( FT_FLEN( fieldname(xx) ) )
              ? "FIELD DECI: ",NTOC( FT_FDEC( fieldname(xx) ) )
              ?
              ? "and...RETURN values passing ordinals"
              ? "  CONTENTS: ",FT_FVAL(xx)
              ? "VALUE LENG: ",NTOC( FT_FVALLEN( (xx) ) )
              ? "FIELD TYPE: ",FT_FTYPE( xx )
              ? "FIELD LENG: ",NTOC(FT_FLEN( xx ))
              ? "FIELD DECI: ",NTOC(FT_FDEC( xx ))
              ?
              end:= Seconds()
              ? "Executed In ",TRANSFORM((end -start),"9.999")," Secs."
              ? "Press Any Key; [Esc] To Get Out Now"
              ? ; key:= INKEY(0); IF key==K_ESC; xx:= fc; END; cls
           NEXT
           IF !EOF(); SKIP; ENDIF
           numrecs--
        ENDDO

        CLOSE ALL
        SETCOLOR(oldcolor)
     ELSE; ? "Bad or No .DBF Parameter"; ?
     ENDIF
     QUIT
  RETURN NIL

#endif


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FVAL()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Return the value of a field
 *  $SYNTAX$
 *     FT_FVAL( <xVar> ) -> xVal
 *  $ARGUMENTS$
 *     <xVar> is either a field name or ordinal field position
 *  $RETURNS$
 *     The value (contents) of the specified field.  NIL if error.
 *  $DESCRIPTION$
 *     FT_FVAL() is used to get the value (contents) of any .DBF field.
 *  $EXAMPLES$
 *     xVal:= FT_FVAL( "unit_prc" )
 *     xVal:= FT_FVAL( 2 )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FVALLEN()  FT_FLEN()  FT_FDEC()  FT_FNUM()  FT_FTYPE()
 *  $END$
 */

FUNCTION FT_FVAL( var )
RETURN (TCHR)


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FTYPE()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Return a field's type
 *  $SYNTAX$
 *     FT_FTYPE( <xVar> ) -> cType
 *  $ARGUMENTS$
 *     <xVar> is either a field name or ordinal field position.
 *  $RETURNS$
 *     The type of field: character (C), numeric (N), date (D), logical (L),
 *     or memo (M).  NIL, if error.
 *  $DESCRIPTION$
 *     FT_FTYPE() is used to get the type of any .DBF field.
 *  $EXAMPLES$
 *     cType:= FT_FTYPE( "unit_prc" )
 *     cType:= FT_FTYPE( 2 )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FVALLEN()  FT_FLEN()  FT_FDEC()  FT_FNUM()  FT_FVAL()
 *  $END$
 */

FUNCTION FT_FTYPE( var )
RETURN (TNUM)


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FLEN()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Return a field's length
 *  $SYNTAX$
 *     FT_FLEN( <xVar> ) -> nLen
 *  $ARGUMENTS$
 *     <xVar> is either a field name or an ordinal field position.
 *  $RETURNS$
 *     The length of the specified field, or -1 if an error occurred.
 *  $DESCRIPTION$
 *     FT_FLEN() is used to get the length of any .DBF field.
 *  $EXAMPLES$
 *     nLen:= FT_FLEN("unit_prc")
 *     nLen:= FT_FLEN( 2 )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FVALLEN()  FT_FDEC()  FT_FNUM()  FT_FTYPE()  FT_FVAL()
 *  $END$
 */

FUNCTION FT_FLEN( var )            // returns -1 if NIL
RETURN IF( (TNUM)=="D",len(dtoc( (TCHR) )),;
       IF( (TNUM)=="L",1,;
       IF( (TNUM)=="M",10,;
       IF( (TNUM)=="C",len( (TCHR) ),;
       IF( (TNUM)=="N",len(str( (TCHR) )),-1 ) ))))


/*  $DOC$
 *  $FUNCNAME$
 *      FT_FVALLEN()
 *  $CATEGORY$
 *      Database
 *  $ONELINER$
 *      Return the length of the value in a field position
 *  $SYNTAX$
 *      FT_FVALLEN( <xVar> ) -> nVlen
 *  $ARGUMENTS$
 *     <xVar> is either a field name or an ordinal field position.
 *  $RETURNS$
 *      The length of the value in a specified field.  -1 if error.
 *  $DESCRIPTION$
 *      FT_FVALLEN() is used to get the length of the value in any .DBF field.
 *  $EXAMPLES$
 *      nVlen:= FT_FVALLEN("unit_prc")
 *      nVlen:= FT_FVALLEN( 2 )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FLEN()  FT_FDEC()  FT_FNUM()  FT_FTYPE()  FT_FVAL()
 *  $END$
 */

FUNCTION FT_FVALLEN( var )
RETURN IF( (TNUM)=="D",len(dtoc( (TCHR) )),;
       IF( (TNUM)=="L",1,;
       IF( (TNUM)=="M",len( ATRIM( (TCHR) ) ),;
       IF( (TNUM)=="C",len( ATRIM( (TCHR) ) ),;
       IF( (TNUM)=="N",len( ATRIM( str((TCHR)) ) ),-1 ) ))))


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FDEC()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Return the number of decimals in a numeric field
 *  $SYNTAX$
 *     FT_FDEC( <xVar> ) -> nDec
 *  $ARGUMENTS$
 *     <xVar> is either a field name or an ordinal field position.
 *  $RETURNS$
 *     The number of decimal places in a numeric field.  -1 if error.
 *  $DESCRIPTION$
 *     FT_FDEC() is used to get the number of decimal places in a numeric
 *     field.
 *  $EXAMPLES$
 *     nDec:= FT_FDEC( "unit_prc" )
 *     nDec:= FT_FDEC( 2 )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FVALLEN()  FT_FLEN()  FT_FNUM()  FT_FTYPE()  FT_FVAL()
 *  $END$
 */

FUNCTION FT_FDEC( var )
RETURN IF( (TNUM)<>"N", -1,;
       IF( (TNUM)=="N" .AND. "." $str( (TCHR) ),;
           len(str( (TCHR) )) -at(".",str( (TCHR) )),0 ))


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FNUM()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Return the ordinal position given the field name
 *  $SYNTAX$
 *     FT_FNUM( <xVar> ) -> nNum
 *  $ARGUMENTS$
 *     <xVar> must be a valid field name.
 *  $RETURNS$
 *     The ordinal position of the field.  -1 if error.
 *  $DESCRIPTION$
 *     FT_FNUM() is used to get the ordinal position of any .DBF field.
 *  $EXAMPLES$
 *     nNum:= FT_FNUM( "unit_prc" )
 *  $SEEALSO$
 *     FT_FPLACE()  FT_FVALLEN()  FT_FLEN()  FT_FDEC()  FT_FTYPE()  FT_FVAL()
 *  $END$
 */

/* hated to write it this way, but there's no other... save 'C' or .ASM
   in the case of a 100-field .DBF, you use more than 1300 bytes memory
   plus overhead for a call that might return as little as 1 byte.  Nah!
*/

FUNCTION FT_FNUM( fldname )
LOCAL dbsarray:= Dbstruct()
RETURN IF(valtype(fldname)=="C",;
          ASCAN( dbsarray, {|e| UPPER(fldname)==e[DBS_NAME] } ), -1 )


/*  $DOC$
 *  $FUNCNAME$
 *     FT_FPLACE()
 *  $CATEGORY$
 *     Database
 *  $ONELINER$
 *     Place a new value in a field
 *  $SYNTAX$
 *     FT_FPLACE( <xVar>,<xVal> ) -> xVal
 *  $ARGUMENTS$
 *     <xVar> is either a field name or ordinal field position.
 *  $RETURNS$
 *     <xVal>, the FT_FPLACE()d value.  NIL if error.
 *  $DESCRIPTION$
 *     FT_FPLACE() is used to place a new value in a specified field.
 *     FT_FPLACE() (except for memo fields) replaces Clipper's REPLACE.
 *  $EXAMPLES$
 *     xVal:= FT_FPLACE( "unit_prc",15.73 )
 *     xVal:= FT_FPLACE( 2, 15.73 )
 *  $SEEALSO$
 *     FT_FVALLEN()  FT_FLEN()  FT_FDEC()  FT_FNUM()  FT_FTYPE()  FT_FVAL()
 *  $END$
 */

FUNCTION FT_FPLACE( var,value )
RETURN IF( (VTV)=="N", Fieldput( var,value ),;
       IF( (VTV)=="C", Eval( (FBV),value ), NIL ))


// EOF: FIELD.prg
