/*
 * File......: NUMLOCK.C
 * Author....: Ted Means
 * Date......: $Date:   02 Apr 1991 18:25:58  $
 * Revision..: $Revision:   1.0  $
 * Log file..: $Logfile:   E:/nanfor/src/numlock.c_v  $
 * 
 * This function is an original work by Ted Means and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log:   E:/nanfor/src/numlock.c_v  $
 * 
 *    Rev 1.0   02 Apr 1991 18:25:58   GLENN
 * Nanforum Toolkit
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *     FT_NUMLOCK()
 *  $CATEGORY$
 *     Keyboard/Mouse
 *  $ONELINER$
 *     Returns status of NumLock key
 *  $SYNTAX$
 *     FT_NUMLOCK() -> lValue
 *  $ARGUMENTS$
 *     None
 *  $RETURNS$
 *     lValue is .T. if NumLock is set, .F. if it isn't set.
 *  $DESCRIPTION$
 *     This function is useful if you need to know the status of the NumLock
 *     key for some reason.
 *  $EXAMPLES$
 *     IF FT_NUMLOCK()
 *        Qout( "NumLock is active" )
 *     ENDIF
 *  $END$
 */

#include <extend.h>

CLIPPER FT_NUMLOCK(void)
{
   _retl( (int) ((*(char *) 0x00000417) & 0x20) );
   return;
}

