; File......: NWTTS2.ASM
; Author....: James Zack
; Date......: $Date:   02 Apr 1991 18:25:18  $
; Revision..: $Revision:   1.0  $
; Log file..: $Logfile:   E:/nanfor/src/nwtts2.asv  $
; 
; This is an original work by James Zack and is placed in the
; public domain.
;
; Modification history:
; ---------------------
;
; $Log:   E:/nanfor/src/nwtts2.asv  $
;  
;     Rev 1.0   02 Apr 1991 18:25:18   GLENN
;  Nanforum Toolkit
;

; $DOC$
; $FUNCNAME$
;     FT_TTSABORT()
; $CATEGORY$
;     Netware
; $ONELINER$
;     Aborts explicit and implicit TTS transactions
; $SYNTAX$
;     FT_TTSABORT() -> nResult
; $ARGUMENTS$
;     None
; $RETURNS$
;       0     Abort Successful (backout completed)
;     253     Transaction Tracking disabled (no backout performed)
;     254     Transaction ended records locked (No backout performed)
;     255     No explicit transactions active
; $DESCRIPTION$
;    Consult your Netware documentation for details on the Netware 
;    Transaction tracking system.
; $EXAMPLES$
;    nResult := FT_TTSABORT()
;    DO CASE
;       CASE nResult == 0
;          ? "TTS aborted"
;       CASE nResult == 253
;          ? "Transction tracking, no backout performed"
;       CASE nResult == 254
;          ? "Transaction ended records locked, no backout performed"
;       CASE nResult == 255
;          ? "No transactions active"
;       OTHERWISE
;          ? "Unknown result"
;    ENDCASE
; $SEEALSO$
;    FT_TTSAVAIL() FT_TTSBEGIN() FT_TTSEND() FT_TTSSTAT()
; $END$
;
;


PUBLIC    Ft_ttsAbort
EXTRN     __RETNI:FAR
extrn     __RET:FAR
_NanFor  SEGMENT 'CODE'
          ASSUME cs:_NanFor
Ft_ttsAbort PROC    FAR
          push    bp
          mov     bp,sp
          push    ds
          push    es
          push    si
          push    di
          mov     ah,0c7h          ; Novell API function c7
          mov     al,03h           ; Subfunction 02
          int     21h              ; TTS Abort Transaction
          mov     ah,00h
          push    ax
          call    __RETNI
          add     sp,2
          pop     di
          pop     si
          pop     es
          pop     ds
          pop     bp
          call    __RET
          ret

Ft_ttsAbort endp

_NanFor   ends

          end
