/*
 * File......: SHIFT.C
 * Author....: Ted Means
 * Date......: $Date:   02 Apr 1991 18:26:10  $
 * Revision..: $Revision:   1.0  $
 * Log file..: $Logfile:   E:/nanfor/src/shift.c_v  $
 * 
 * This is an original work by Ted Means and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log:   E:/nanfor/src/shift.c_v  $
 * 
 *    Rev 1.0   02 Apr 1991 18:26:10   GLENN
 * Nanforum Toolkit
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *     FT_SHIFT()
 *  $CATEGORY$
 *     Keyboard/Mouse
 *  $ONELINER$
 *     Determine status of shift key
 *  $SYNTAX$
 *     FT_SHIFT() -> lValue
 *  $ARGUMENTS$
 *     None
 *  $RETURNS$
 *     .T. if a shift key is pressed, .F. if otherwise.
 *  $DESCRIPTION$
 *     This function is useful for times you need to know whether or not the
 *     shift key is pressed, such as during a MemoEdit().
 *  $EXAMPLES$
 *     IF FT_SHIFT()
 *        @24, 0 say "Shift"
 *     ELSE
 *        @24, 0 say "     "
 *     ENDIF
 *  $END$
 */

#include <extend.h>

CLIPPER FT_SHIFT(void)
{
   _retl( (int) ((*(char *) 0x00000417) & 0x3) );
   return;
}
